#!/bin/bash

# Copyright (c) 2021 by Apex.AI Inc. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# SPDX-License-Identifier: Apache-2.0

# This script remove trailing whitespaces and runs clang-format
# on the modified file

current_dir=$(pwd)
repo_root_dir=$(git rev-parse --show-toplevel)

cd "${repo_root_dir}" || exit

if ! tools/scripts/clang_tidy_check.sh hook; then
    echo "Error while executing clang-tidy"
    exit 1
fi

## remove trailing whitespaces
files=$(git diff --cached --name-only --diff-filter=ACMRT)
if [[ -n ${files} ]]; then
    echo "Removing Whitespaces on the following file(s):"
    echo "--------------------------------------------"
    echo "${files}"
    echo
    for file in $files ; do
        if [ -f $file ]; then
            sed -i 's/\s*$//g' "$file"
            git add "$file"
        fi
    done
fi

## clang-format
if ! tools/scripts/clang_format.sh hook; then
    echo "Error while executing clang-format"
    exit 1
fi

cd "${current_dir}" || exit
